// ConsoleApplicationCRC.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <stdint.h>

uint16_t Get_Buf_CRC(unsigned char* ptr, uint16_t numbytes);
uint16_t Update_CRC(uint16_t crc, unsigned char newbyte);

char someStuff[] = "Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz Hello WorldЪuz ";

int main()
{
    std::cout << "Hello World!\n";
    unsigned char* bufferPtr = (unsigned char*) someStuff;
    printf("CRC value: %d", Get_Buf_CRC(bufferPtr, 221));
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file

uint16_t Get_Buf_CRC(unsigned char* ptr, uint16_t numbytes) {
    uint16_t i, CRC;
    CRC = 0x0000;
    // Process each byte in the buffer into the running CRC
    for (i = 0; i < numbytes; i++) {
        CRC = Update_CRC(CRC, *ptr++);
    }
    return(CRC);
}

uint16_t Update_CRC(uint16_t crc, unsigned char newbyte) {
    unsigned char i; // loop counter
#define POLY 0x8408                 // CRC16-CCITT FCS (X^16+X^12+X^5+1)
    crc = crc ^ newbyte;
    for (i = 0; i < 8; i++) {
        if (crc & 0x01) {
            crc = crc >> 1;
            crc ^= POLY;
        }
        else {
            crc = crc >> 1;
        }
    }
    return(crc);
}